#include "sorting.h"
#include<iostream>


void merge(vector<int>& inp, int start, int middle, int end) {
	int p = start,q = middle+1;
	int array[end-start+1] ;
	int k=0 ;
	for(int i=start;i<=end;i++) {
	    if(p>middle)
	        array[k++] = inp[q++] ;
	    else if(q>end)
	        array[k++] = inp[p++];
	    else if(inp[p]<inp[q])
	        array[k++] = inp[p++];
	    else
	        array[k++] = inp[q++];
    }
    for(int i=start ; i<=end ; i++){
    	inp[i]=array[i-start] ;
    }
}


void merge_sort(vector<int>& inp, int start, int end)
{
	if(start < end){
		int middle = (start + end)/2 ;
	    merge_sort(inp,start,middle) ;
	    merge_sort(inp,middle+1,end) ;
	    merge(inp,start,middle,end); 
	}
}


vector<int> sort_custom(vector<int> inp, int startidx, int endidx){
    merge_sort(inp,startidx,endidx) ; 
	return inp;
}